Subject: Re: [PATCH 2/6] builtin/update-index: end ODB transaction when --verbose is specified

From: Patrick Steinhardt <[email-masked]>
Date: Mon, 15 Sep 2025 08:08:41 +0200

On Thu, Sep 11, 2025 at 10:34:42AM -0500, Justin Tobler wrote:
> On 25/09/11 08:40AM, Patrick Steinhardt wrote:
> > On Tue, Sep 09, 2025 at 02:11:30PM -0500, Justin Tobler wrote:
> > > With 23a3a303 (update-index: use the bulk-checkin infrastructure,
> > > 2022-04-04), object database transactions were added to
> > > git-update-index(1) to facilitate writing objects in bulk. With
> > > transactions, newly added objects are instead written to a temporary
> > > object directory and migrated to the primary object database upon
> > > transaction commit.
> > > 
> > > When the --verbose option is specified, each individual object is
> > > explicitly flushed via flush_odb_transaction() prior to reporting the
> > > update. Flushing the object database transaction migrates pending
> > > objects to the primary object database without marking the transaction
> > > as complete. This is done so objects are immediately visible to
> > > git-update-index(1) callers using the --verbose option and that rely on
> > > parsing verbose output to know when objects are written.
> > > 
> > > As soon as verbose output is requested in git-update-index(1), all
> > > subsequent object writes are flushed prior to being reported and thus no
> > > longer benefit from being transactional. Furthermore, the mechanism to
> > > flush a transaction without committing is rather awkward. Drop the call
> > > to flush_odb_transaction() in favor of ending the transaction early when
> > > the --verbose flag is encountered.
> > 
> > Okay, this interface feels somewhat weird indeed. If we now end the
> > transaction early, does the transaction still serve any purpose at all?
> > Like, do we use it to batch steps _before_ we start reporting stuff?
> 
> We only start reporting updates when the --verbose option is first
> encountered. Options are not all processed upfront. This means in the
> follow example:
> 
>   $ git update-index --add foo --add bar --verbose --stdin
> 
> both "foo" and "bar" are silently added via a transaction. After the
> --verbose option, subsequent updates are reported. At this point there
> is no reason for the transaction to continue as all subsequent object
> writes must be fully written before being reported. Thus the transaction
> is ended early.

That's... huh. I really have no idea, but is this design intentional or
an accident?

Patrick